openshot::CacheMemory Class Reference

This class is a memory-based cache manager for Frame objects. More...

`#include <CacheMemory.h>`

Inheritance diagram for openshot::CacheMemory:

## Public Member Functions

void | Add (std::shared_ptr< Frame > frame)
| Add a Frame to the cache. More...
| CacheMemory ()
| Default constructor, no max bytes. More...
| CacheMemory (int64_t max_bytes)
| Constructor that sets the max bytes to cache. More...
void | Clear ()
| Clear the cache of all frames. More...
int64_t | Count ()
| Count the frames in the queue. More...
int64_t | GetBytes ()
| Gets the maximum bytes value. More...
std::shared_ptr< Frame > | GetFrame (int64_t frame_number)
| Get a frame from the cache. More...
std::shared_ptr< Frame > | GetSmallestFrame ()
| Get the smallest frame number. More...
string | Json ()
| Get and Set JSON methods. More...
Json::Value | JsonValue ()
| Generate Json::JsonValue for this object. More...
void | MoveToFront (int64_t frame_number)
| Move frame to front of queue (so it lasts longer) More...
void | Remove (int64_t frame_number)
| Remove a specific frame. More...
void | Remove (int64_t start_frame_number, int64_t end_frame_number)
| Remove a range of frames. More...
void | SetJson (string value)
| Load JSON string into this object. More...
void | SetJsonValue (Json::Value root)
| Load Json::JsonValue into this object. More...
| ~CacheMemory ()
Public Member Functions inherited from openshot::CacheBase
| CacheBase ()
| Default constructor, no max bytes. More...
| CacheBase (int64_t max_bytes)
| Constructor that sets the max bytes to cache. More...
int64_t | GetMaxBytes ()
| Gets the maximum bytes value. More...
void | SetMaxBytes (int64_t number_of_bytes)
| Set maximum bytes to a different amount. More...
void | SetMaxBytesFromInfo (int64_t number_of_frames, int width, int height, int sample_rate, int channels)
| Set maximum bytes to a different amount based on a ReaderInfo struct. More...

## Additional Inherited Members

Protected Attributes inherited from openshot::CacheBase
string | cache_type
| This is a friendly type name of the derived cache instance. More...
CriticalSection * | cacheCriticalSection
| Section lock for multiple threads. More...
int64_t | max_bytes
| This is the max number of bytes to cache (0 = no limit) More...

## Detailed Description

This class is a memory-based cache manager for Frame objects.

It is used by FileReaders (such as FFmpegReader) to cache recently accessed frames. Due to the high cost of decoding streams, once a frame is decoded, converted to RGB, and a Frame object is created, it critical to keep these Frames cached for performance reasons. However, the larger the cache, the more memory is required. You can set the max number of bytes to cache.

Definition at line 48 of file CacheMemory.h.

## Constructor & Destructor Documentation

## CacheMemory() [1/2]

CacheMemory::CacheMemory | ( |  | ) |

Default constructor, no max bytes.

Definition at line 34 of file CacheMemory.cpp.

## CacheMemory() [2/2]

CacheMemory::CacheMemory | ( | int64_t | max_bytes | ) |

Constructor that sets the max bytes to cache.

Parameters

  max_bytes | The maximum bytes to allow in the cache. Once exceeded, the cache will purge the oldest frames.

Definition at line 42 of file CacheMemory.cpp.

## ~CacheMemory()

CacheMemory::~CacheMemory | ( |  | ) |

Definition at line 50 of file CacheMemory.cpp.

## Member Function Documentation

## Add()

void CacheMemory::Add | ( | std::shared_ptr< Frame > | frame | ) |

virtual

Add a Frame to the cache.

Parameters

  frame | The openshot::Frame object needing to be cached.

Implements openshot::CacheBase.

Definition at line 130 of file CacheMemory.cpp.

## Clear()

void CacheMemory::Clear | ( |  | ) |

virtual

Clear the cache of all frames.

Implements openshot::CacheBase.

Definition at line 278 of file CacheMemory.cpp.

## Count()

int64_t CacheMemory::Count | ( |  | ) |

virtual

Count the frames in the queue.

Implements openshot::CacheBase.

Definition at line 290 of file CacheMemory.cpp.

## GetBytes()

int64_t CacheMemory::GetBytes | ( |  | ) |

virtual

Gets the maximum bytes value.

Implements openshot::CacheBase.

Definition at line 193 of file CacheMemory.cpp.

## GetFrame()

std::shared_ptr< Frame > CacheMemory::GetFrame | ( | int64_t | frame_number | ) |

virtual

Get a frame from the cache.

Parameters

  frame_number | The frame number of the cached frame

Implements openshot::CacheBase.

Definition at line 155 of file CacheMemory.cpp.

## GetSmallestFrame()

std::shared_ptr< Frame > CacheMemory::GetSmallestFrame | ( |  | ) |

virtual

Get the smallest frame number.

Implements openshot::CacheBase.

Definition at line 171 of file CacheMemory.cpp.

## Json()

string CacheMemory::Json | ( |  | ) |

virtual

Get and Set JSON methods.

Generate JSON string of this object

Implements openshot::CacheBase.

Definition at line 321 of file CacheMemory.cpp.

## JsonValue()

Json::Value CacheMemory::JsonValue | ( |  | ) |

virtual

Generate Json::JsonValue for this object.

Implements openshot::CacheBase.

Definition at line 328 of file CacheMemory.cpp.

## MoveToFront()

void CacheMemory::MoveToFront | ( | int64_t | frame_number | ) |

Move frame to front of queue (so it lasts longer)

Parameters

  frame_number | The frame number of the cached frame

Definition at line 252 of file CacheMemory.cpp.

## Remove() [1/2]

void CacheMemory::Remove | ( | int64_t | frame_number | ) |

virtual

Remove a specific frame.

Parameters

  frame_number | The frame number of the cached frame

Implements openshot::CacheBase.

Definition at line 211 of file CacheMemory.cpp.

## Remove() [2/2]

void CacheMemory::Remove | ( | int64_t | start_frame_number,
|  | int64_t | end_frame_number
| ) |  |

virtual

Remove a range of frames.

Parameters

  start_frame_number | The starting frame number of the cached frame
  end_frame_number | The ending frame number of the cached frame

Implements openshot::CacheBase.

Definition at line 217 of file CacheMemory.cpp.

## SetJson()

void CacheMemory::SetJson | ( | string | value | ) |

virtual

Load JSON string into this object.

Implements openshot::CacheBase.

Definition at line 353 of file CacheMemory.cpp.

## SetJsonValue()

void CacheMemory::SetJsonValue | ( | Json::Value | root | ) |

virtual

Load Json::JsonValue into this object.

Implements openshot::CacheBase.

Definition at line 376 of file CacheMemory.cpp.

The documentation for this class was generated from the following files:

- CacheMemory.h
- CacheMemory.cpp